/*
 * File Timing.cpp
 *
 *  Description:
 *
 *  Author: Christopher Richard
 *
 *  Date: 11/17/96
 */

#include "timing.h"

#define noDEBUG_TIMING

#ifdef DEBUG_TIMING
void interrupt ( *oldhandler)(...);
void interrupt interruptBeacon(...);
unsigned int count;
void main (void)
{
	setSampleRate();
	/* save the old interrupt vector */
   oldhandler = getvect(0x1c);

    /* install the new interrupt handler */
   setvect(0x1c, interruptBeacon);

   while(!kbhit()){
   	if (count==600){
      	cprintf("beep");
         count=0;
   	}
   }
   setvect(0x1c, oldhandler);
   resetTimer();
}

void interrupt interruptBeacon(...)
{
	count++;
}

#endif

void setSampleRate(void)
{
	float sampleFreq;

	clrscr(); /*clear the screen */

   gotoxy(5,10);
	cprintf("Enter the desired sampling freq in Hz");
   cscanf("%f", &sampleFreq);
//cprintf("sampleFreq = %f", sampleFreq);
   flushKBbuffer();

   setTimer( sampleFreq );

}

float setTimer( float sampleFreq )
{
	unsigned divisor;
   char lowByte, highByte;

	//cprintf("sampleFreq = %f", sampleFreq);
	if (sampleFreq > CLK_FREQ) {
		cprintf("\r\nMaximum sample rate is %f\r\n", CLK_FREQ);
   	divisor = 1;
 	} else if (sampleFreq <= MIN_FREQ) {
   	cprintf("\r\nMinimum sample rate is %f\r\n", MIN_FREQ);
  		divisor = 0;
	} else {
   	divisor = (CLK_FREQ/sampleFreq);
   }
	//cprintf("\r\ndivisor =%u",divisor);
   lowByte = (divisor & 0x00ff);
	highByte = (divisor & 0xff00) >> 8;

	if (divisor !=0) {
		/*cprintf("\r\nActual Sampling rate will be: %f(Hz)", (CLK_FREQ/divisor));*/
   }
   outp(CONTROL_REG,CTR0_MODE2);   /* set CTR0 in mode2, with low then high write */
   outp(CTR0,lowByte); /* write low byte of divisor */
   outp(CTR0,highByte);	/* write high byte of divisor */

   return(CLK_FREQ/divisor);
}

void resetTimer(void)
{
	setTimer( MIN_FREQ ); /* reset timer to 18.2064 Hz */
}

void waitTilNextTick(void) {

}

void flushKBbuffer(void) {
	while(kbhit()) {
   	getch();
   }
}
